CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     RAM-based Spin Interpreter Test - Step 2                                  RamVm_Step2.spin      *
' *                                                                                                     *
' *******************************************************************************************************
'
' Same as Step 1 but here we launch the ROM Interpreter ( in ROM at $F004 ) as PASM and passing in the
' modified Program header at $0004 so it runs the sand-boxed spin test code.

PRI Version

  result := String( "RamVm_Step2" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  TV_PIN        = 12

  LED_PIN       = 9
  
OBJ

  tv            : "TV_Text"


VAR

  long number

  long stack[1000]

PUB Main( running )

  tv.Start( TV_PIN )
  
  if not running
    running := true

    word[ $0004 ] := word[ $0004 ]                      ' $0004 Clock Setting / Checksum
    word[ $0006 ] := word[ $0006 ]                      ' $0006 Object Base
    word[ $0008 ] := word[ $0008 ]                      ' $0008 Var Base
    word[ $000A ] := @stack                             ' $000A Stack Base
    word[ $000C ] := AtSpinCode                         ' $000C Initial PC
    word[ $000E ] := @stack+4                           ' $000E Stack Top
  
    CogNew( $F004, $0004 )

  repeat
    tv.Out( $01 )
    tv.Str( Version )
    tv.Out( $0D )
    Tv.Dec( number )
    
PUB SpinCode ' This must be the second method !

  DIRA[ LED_PIN ] := 1
  repeat
    number++
    ! OUTA[ LED_PIN ]
    PauseMs( 250 )

PRI PauseMs( ms )

  waitcnt( CLKFREQ / 1000 * ms + CNT )

PRI AtSpinCode                                          ' Faked result := @SpinCode
  result := word[ $0006 ]
  result := word[ result ][4] + result
  