CON
           
' *******************************************************************************************************
' *                                                                                                     *
' *     RAM-based Spin Interpreter Test - Step 5                                  RamVm_Step5.spin      *
' *                                                                                                     *
' *******************************************************************************************************
'
' Same as Step 4 except the RAM interpreter has been moved to a sub-object to show what little change has
' to be made to an end user program to use that. As in step 4 we do not yet support CogNew or CogInit so
' oly single Cog operation, no TV, only LED flashing.

PRI Version

  result := String( "RamVm_Step5" )
  
CON

  _CLKMODE      = XTAL1 + PLL16x
  _XINFREQ      = 7_372_800                             ' 118MHz Operation ! Works for me on ProtoBoard :-)

  LED_PIN       = 9

OBJ

  RamInterpreter : "RamVm_Step5_Interpreter"
    
VAR

  long number

PUB Main( running )

  if not running
    running := true
    RamInterpreter.Start

  DIRA[ LED_PIN ] := 1
  repeat
    number++
    ! OUTA[ LED_PIN ]
    PauseMs( 250 )

PRI PauseMs( ms )

  waitcnt( CLKFREQ / 1000 * ms + CNT )
